typedef struct link_type
{
  struct link_type *next;		// next link in the list
  void             *data;		// data pointed to by link
} link_t;

// prototypes for link management functions
link_t*	link_init(void* data);

typedef struct list_type
{
  link_t  *first;			// first link in the list
  link_t  *last;			// last link in the list
  link_t  *current;			// list iterator
} list_t;

// prototypes for list management functions
list_t*	list_init(void);		// malloc new list header and init
void	list_add(list_t*,void *);	// add an element to end of a list
void	list_del_front_link(list_t*);	// delete front link
void	list_del(list_t*);		// delete all list structures and items
void	list_reset(list_t*);		// reset internal list iterator
int	list_not_end(list_t*);		// check for end of list
void	list_next_link(list_t*);	// advance iterator
void	*list_get_data(list_t*);	// return user data
